<?php
	
	require_once("includes_php.php");
	
?>
<!doctype html>
<html ng-app="HafeApp">
	<head>
		<!-- Indiquem el tag <base> per a que AngularJS pugui utilitzar el mode HTML5 -->
		<?php 
			if(PRODUCTION == 0){
				
				echo '<base href="/tfg/">';
			
			}else{
				
				echo '<base href="/~albertnevado/tfg/">';
			
			}
		?>
		<meta charset="utf-8" />
		<meta name="viewport" content="width=device-width, initial-scale=1.0"/>
		<title>HafeApp</title>
		
		<!-- Mobile webapp capable -->
		<link rel="manifest" href="manifest.json">
		<meta name="mobile-web-app-capable" content="yes">
		<link rel="icon" sizes="192x192" href="images/icon-192.png">
		
		<!-- Styles -->
		<link href="styles/vendor/fontawesome/css/font-awesome.min.css" rel="stylesheet"></style>
		<link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
		<link href="styles/vendor/bootstrap/bootstrap.min.css" rel="stylesheet"></style>
		<link href="styles/vendor/materialize/materialize.css" rel="stylesheet"></style>
		<link href="styles/vendor/notificationfx/ns-default.css" rel="stylesheet"></style>
		<link href="styles/vendor/notificationfx/ns-style-attached.css" rel="stylesheet"></style>
		<link href="styles/vendor/notificationfx/ns-style-bar.css" rel="stylesheet"></style>
		<link href="styles/general.css" rel="stylesheet"></style>
		<link href="styles/login.css" rel="stylesheet"></style>
		<link href="styles/user.css" rel="stylesheet"></style>
		<link href="styles/options.css" rel="stylesheet"></style>
		<link href="styles/card-edition.css" rel="stylesheet"></style>
		<link href="styles/material-input.css" rel="stylesheet"></style>
		<link href="styles/user-property.css" rel="stylesheet"></style>
		<link href="styles/user-profile.css" rel="stylesheet"></style>
		<link href="styles/visualizations.css" rel="stylesheet"></style>
		<link href="styles/alerts.css" rel="stylesheet"></style>
		
		<!-- Includes -->
		<script src="scripts/manifest.porting.js"></script>
		<script src="scripts/vendor/jquery/jquery-3.2.0.min.js"></script>
		<script src="scripts/vendor/angularjs/angular.min.js"></script>
		<script src="scripts/vendor/angularjs/angular-route.min.js"></script>
		<script src="scripts/vendor/materialize/materialize.js"></script>
		<script src="scripts/vendor/notificationfx/classie.js"></script>
		<script src="scripts/vendor/notificationfx/snap.svg-min.js"></script>
		<script src="scripts/vendor/notificationfx/modernizr.custom.js"></script>
		<script src="scripts/vendor/notificationfx/notificationFx.js"></script>
		<script src="scripts/vendor/qrcodejs/qrcode.min.js"></script>
		<script src="scripts/general.js"></script>
		
		<!-- Modules -->
		<script src="scripts/modules/user.mdl.js"></script>
		<script src="scripts/modules/user.properties.mdl.js"></script>
		<script src="scripts/modules/cards.mdl.js"></script>
		<script src="scripts/modules/card.preferences.mdl.js"></script>
		<script src="scripts/modules/options.mdl.js"></script>
		<script src="scripts/modules/login.mdl.js"></script>
		<script src="scripts/modules/visualizations.mdl.js"></script>
		<script src="scripts/modules/auth.mdl.js"></script>
		<script src="scripts/modules/emergency.alerts.mdl.js"></script>
		
		<!-- Services -->
		<script src="scripts/services/auth.srv.js"></script>
		<script src="scripts/services/user.properties.srv.js"></script>
		<script src="scripts/services/user.visualizations.srv.js"></script>
		<script src="scripts/services/card.preferences.srv.js"></script>
		<script src="scripts/services/alerts.srv.js"></script>
		
		<!-- App setup -->
		<script src="scripts/app.js"></script>
		<script src="scripts/routes.js"></script>
		
		<!-- Directives -->
		<script src="scripts/directives/material-input.drv.js"></script>
		<script src="scripts/directives/user-property.drv.js"></script>
		<script src="scripts/directives/elastic-textarea.drv.js"></script>
		<script src="scripts/directives/user-profile.drv.js"></script>
		
		<!-- Controllers -->
		<script src="scripts/controllers/nav.ctrl.js"></script>
		<script src="scripts/controllers/user.ctrl.js"></script>
		<script src="scripts/controllers/cards.ctrl.js"></script>
		<script src="scripts/controllers/options.ctrl.js"></script>
		<script src="scripts/controllers/welcome.ctrl.js"></script>
		<script src="scripts/controllers/lostPassword.ctrl.js"></script>
		<script src="scripts/controllers/login.ctrl.js"></script>
		<script src="scripts/controllers/signup.ctrl.js"></script>
		<script src="scripts/controllers/visualizations.ctrl.js"></script>
		<script src="scripts/controllers/send-alert.ctrl.js"></script>
		<script src="scripts/controllers/view-alert.ctrl.js"></script>
		<script src="scripts/controllers/view.ctrl.js"></script>
		<script src="scripts/controllers/restorePassword.ctrl.js"></script>
		
		<!-- Dynamically generated meta -->
		
	</head>
	<body data-ng-cloak>
		<div id="page-wrapper" data-ng-controller="HafeController as hafe">
			<ul data-ng-show="hafe.isLogged" id="nav_menu" class="side-nav fixed" data-ng-controller="NavController as Nav">
				<li>
					<div class="menu_logo_container"></div>
				</li>
				<li data-ng-repeat="item in Nav.items" data-ng-class="{active: Nav.isActive(item)}">
					<a href="{{item.path}}"><i class="fa fa-{{item.icon}}"></i><span>{{item.title}}</span></a>
				</li>
				<li><a ng-click="hafe.logout()"><i class="fa fa-sign-out"></i><span>Sortir</span></a></li>
			</ul>
			<div class="top_bar_menu" data-ng-show="hafe.isLogged || hafe.hasAccess()" data-ng-class="{has_access: hafe.hasAccess()}">	
				<a data-ng-show="hafe.isLogged" data-activates="nav_menu" class="main_menu_trigger"><i class="fa fa-bars"></i></a>
			</div>
			<div id="content_wrapper" ng-class="{not_logged: !hafe.isLogged}">
				<div data-ng-view></div>
			</div>
		</div>
		<script>
			var global_url = '<?php echo get_app_url(); ?>';
			
			$('.main_menu_trigger').sideNav({
				draggable: true // Choose whether you can drag to open on touch screens
			});
			
			$(document).on('click touchdown', '.side-nav li a', function(e) {
				// https://github.com/Dogfalo/materialize/issues/1426
				windowsize = $(window).width();
				if (windowsize < 992) {
					$('.main_menu_trigger').sideNav('hide');
				}
			});
			
			// background image: https://www.pexels.com/photo/action-adult-affection-eldery-339620/
		</script>
	</body>
</html>