(function(){
	var app = angular.module(
		"HafeApp", 
		/* Hi indiquem les dependències */
		[
			'ngRoute', 
			'hafe-options', 
			'hafe-user', 
			'hafe-card', 
			'hafe-options',
			'hafe-visualizations',
			'hafe-alerts',
			'hafe-auth'
		]
	);
	
	app.controller("HafeController", ['$scope', 'AuthService', '$location', function($scope, AuthService, $location){
		var ao = this;
		
		ao.unloggedPages = ['login', 'send-alert', 'restore-password'];
		
		ao.isLogged = false;
		
		ao.hasAccess = function(){
			return ao.getCurrentPage() == 'send-alert';
		};
		
		ao.isMobile = function(){
			return true;
		};
		
		ao.getCurrentPage = function(){
			return $location.path().split("/")[1];
		};
		
		ao.logout = function(){
			AuthService.logout();
			ao.isLogged = false;
			$location.path('/login');
		};
		
		$scope.$on('$routeChangeSuccess', function () {
			// Aquesta funció es crida cada cop que canviem de ruta, és a dir, accedim a una pàgina
			$(".ns-box:not(.ntf_persistent)").remove();
			
			AuthService.validateToken(false).done(function(resp){
				// Posem el valor de la variable conforme si està autenticat
				if(ao.getCurrentPage() != 'login') ao.isLogged = resp;
				
				if(!ao.isLogged && ao.unloggedPages.indexOf(ao.getCurrentPage()) == -1){
					// Si no ho està, el retornem a la pàgina de login
					$location.path('/login');
				}
				
				setTimeout(function(){$scope.$apply()});
			});
		});
		
	}]);
})();