(function(){
	var app = angular.module("hafe-auth");
	
	app.controller("LoginController", ['$scope', 'AuthService', '$location', '$routeParams', function($scope, AuthService, $location, $routeParams){
		var ao = this;
		
		$scope.user = {
			mail: localStorage['mail'] || '',
			password: ''
		};
		
		ao.init = function(){
			AuthService.logout();
		};
		
		ao.loginUser = function(){
			var _mail = $scope.user.mail;
			var _password = $scope.user.password;
			
			AuthService.loginUser(_mail, _password)
			.done(function(msg){
				msg = JSON.parse(msg);
				
				var login_response = AuthService.processLogin(msg);
				
				if(login_response){
					if($routeParams.alertCode){
						$location.path('/view-alert/'+$routeParams.alertCode);
					}else if($routeParams.viewCode){
						$location.path('/view/'+$routeParams.viewCode);
					}else{
						$location.path('/home');
					}
					setTimeout(function(){$scope.$apply()});
				}else{
					showNotification('error', false, "Combinació d'usuari i contrasenya incorrectes.");
				}
			});
		};
		
		ao.activateUser = function(_code){
			AuthService.activateUser(_code)
			.done(function(resp){
				resp = JSON.parse(resp);
				
				if(resp.status == 'success'){
					showNotification('success', false, "Usuari validat correctament. Ja pots iniciar sessió.");
					$scope.user.mail = resp.data.user.mail;
					setTimeout(function(){$scope.$apply();});
				}else{
					if(resp.status_id == 'invalid_code'){
						showNotification('error', false, "El codi de validació no és correcte i no hem pogut validar l'usuari.");
					}else{
						showNotification('error', false, "No hem pogut validar l'usuari correctament. Intenta-ho de nou, sisplau.");
					}
				}
			});
		};
		
		if($routeParams.activateCode){
			ao.activateUser($routeParams.activateCode);
		}
		
		ao.init();
		
	}]);
})();