(function(){
	var app = angular.module("hafe-options");
	
	app.controller("OptionsController", ['$scope', '$timeout', 'AuthService', '$location', function($scope, $timeout, AuthService, $location){
		var ao = this;
		
		$scope.user = {};
		ao.deleteText = '';
		
		ao.init = function(){
			ao.loadUserInfo();
		};
		
		ao.loadUserInfo = function(){
			AuthService.getUserInfo()
			.done(function(resp){
				resp = JSON.parse(resp);
				
				if(resp.status == 'success'){
					$scope.user = resp.data.user;
					$scope.user.password = "";
					$scope.user.confirm_password = "";
					$scope.$apply();
				}
			});
		};
		
		ao.saveOptions = function(){
			if($scope.optionsForm.$valid){
				$.ajax({
					type: 'post',
					url: 'server/options/save.php',
					data: {token: AuthService.getToken(), user: JSON.stringify($scope.user)}
				}).done(function(resp){
					resp = JSON.parse(resp);
					
					if(resp.status = 'success'){
						showNotification('success', false, "Els canvis s'han desat correctament.");
					}else{
						showNotification('error', false, "No s'han pogut guardar els canvis.");
						console.log(resp);
					}
				})
			}else{
				if($scope.user.password != $scope.user.confirm_password){
					showNotification('error', false, "Les contrasenyes no coincideixen.");
				}else{
					showNotification('error', false, "Tots els camps són obligatoris.");
				}
			}
		};
		
		$scope.uploadPhoto = function(){
			var fd = new FormData(document.querySelector('form[name="photoForm"]'));
			//https://www.formget.com/ajax-image-upload-php/
			$.ajax({
				url: "server/media/upload_file.php",
				type: "POST",
				data: fd,
				contentType: false,
				cache: false,
				processData:false
			}).done(function(resp){
				resp = JSON.parse(resp);
				console.log(resp);
				if(resp.status == 'success'){
					$scope.user.photo = resp.data.photo.src;
					$scope.$apply();
				}else{
					if(resp.status_id = 'invalid_extension'){
						showNotification('error', false, "Extensió d'imatge invàlida.");
					}else{
						showNotification('error', false, "No s'ha pogut pujar l'arxiu. Torna-ho a intentar en una estona.");
					}
				}
			});
		};
		
		ao.wantsToDelete = function(){
			var wants = ao.deleteText.toLowerCase() == 'esborrar';
			
			if(wants){
				setTimeout(function(){
					ao.deleteText = '';
					$scope.$apply();
				}, 5000);
			}
			
			return wants;
		};
		
		ao.deleteAccount = function(){
			AuthService.deleteAccount()
			.done(function(resp){
				resp = JSON.parse(resp);
				
				if(resp.status == 'success'){
					showNotification('success', false, "Compte esborrat correctament.");
					$timeout(function(){ 
						$location.path('/login');
					}, 3000);
				}else{
					
				}
			});
		};
		
		ao.init();
	}]);
})();