(function(){
	var app = angular.module("hafe-alerts");
	
	app.controller("SendAlertController", ['$scope', '$http', '$routeParams', '$location', 'AlertsService', 'AuthService', function($scope, $http, $routeParams, $location, AlertSrv, AuthSrv){
		var ao = this;
		
		$scope.code = $routeParams.viewCode;
		
		ao.init = function(){
			ao.checkCode();
			return false;
		};
		
		ao.checkCode = function(){
			AuthSrv.checkUserCode($scope.code)
			.done(function(resp){
				resp = JSON.parse(resp);
				
				if(resp.status != 'success'){
					$location.path('/login');
					setTimeout(function(){$scope.$apply()});
					showNotification('error', false, "El codi d'usuari no és vàlid.", false, true);
				}
			});
		};
		
		ao.goBack = function(){
			$location.path("/login");
			setTimeout(function(){$scope.$apply()});
		};
		
		ao.sendAlert = function(){
			if(navigator.geolocation){
				navigator.geolocation.getCurrentPosition(
					function(loc) {
						var lat = loc.coords.latitude;
						var lng = loc.coords.longitude;
						
						AlertSrv.sendAlert($scope.code, lat, lng)
						.done(function(resp){
							resp = JSON.parse(resp);
							
							if(resp.status == 'success'){
								showNotification('success', false, "Alerta enviada. Gràcies per utilitzar els nostres serveis.");
							}else{
								ao.alertNotSent();
							}
						});
					},
					function(err){
						ao.geolocationNotAvailable();
					}
				);
			}else{
				ao.geolocationNotAvailable();
			}
		};
		
		ao.alertNotSent = function(){
			$(".send_alert_content").addClass("not_available");
			showNotification('error', false, "No hem pogut enviar l'alerta. Sisplau, utilitza la opció de la trucada.");
		};
		
		ao.geolocationNotAvailable = function(){
			$(".send_alert_content").addClass("not_available");
			showNotification('error', false, "No s'ha pogut accedir a les dades de localització. Sisplau, utilitza la opció de la trucada.");
		};
		
		// Executem les funcions en quant es carregui el controlador
		ao.init();
	}]);
})();