(function(){
	// No posem les dependencies ja que com l'estem declarant per segon cop, no es pot
	var app = angular.module("hafe-auth");
	
	// Creem el controller per al formulari de registre
	app.controller("SignupController", ['$scope', 'AuthService', '$location', function($scope, AuthService, $location){
		var ao = this;
		
		// Creem l'objecte 'user' assignat a l'scope, atès que així és possible fer el two-way data-binding
		$scope.user = {
			mail: '',
			name: '',
			surname: '',
			password: '',
			rep_password: ''
		}
		
		// Definim la funció que s'encarregarà de registrar l'usuari
		ao.signupUser = function(){
			var _mail = $scope.user.mail
			var _name = $scope.user.name
			var _surname = $scope.user.surname
			var _password = $scope.user.password
			
			$.ajax({
				type: 'post',
				url: 'server/auth/signup.php',
				data: {mail: _mail, name: _name, surname: _surname, password: _password}
			}).done(function(resp){
				resp = JSON.parse(resp)
				console.log(resp);
				if(resp.status == 'success'){
					if(resp.status_id == 'already_exists'){
						showNotification('warning', false, "Aquest correu electrònic ja ha estat utilitzat.");
					}else{
						showNotification('success', false, "Registre completat. S'ha enviat un correu de confirmació a l'adreça especificada.");
					}
				}else{
					showNotification('error', false, "No ha estat possible completar el registre.");
				}
			})
		};
	}]);
	
	app.directive("fieldMatches", function() {
		return {
			require: "ngModel",
			// Creem un scope issolat, és a dir, que és independent
			scope: {
				// I li assignem el valor de l'atribut field-matches
				// Li passem el signe =, doncs així *evalua* l'expressió que hi hagi a field-matches (que retornarà ~user.password)
				// Li podríem passar una @, però llavors no evaluaria si no que agafaria directament el valor literal ("user.password")
				fieldMatches: "="
			},
			// Especifiquem la funció de la Directive: li passem l'scope, l'element i els atributs (paràmetres indispensables)
			link: function(scope, element, attributes, ngModel) {
				// Afegim el mètode que utilitzarà el validador (retorna true o false)
				ngModel.$validators.fieldMatches = function(modelValue) {
					return modelValue == scope.fieldMatches;
				};
				
				// Li diem que cada cop que canviï el valor d'aquest control, torni a revalidar-lo
				scope.$watch("fieldMatches", function() {
					ngModel.$validate();
				});
			}
		};
	});
})();