(function(){
	var app = angular.module("hafe-user");
	
	app.controller("UserController", ['$scope', '$http', 'PropertiesService', 'AuthService', function($scope, $http, PropertiesService, AuthService){
		var ao = this;
		
		$scope.user = {};
		$scope.properties = [];
		$scope.activeProperty = {};
		$scope.editMode = false;
		
		ao.init = function(){
			ao.loadUserInfo();
			ao.loadProperties();
		};
		
		ao.loadUserInfo = function(){
			AuthService.getUserInfo()
			.done(function(resp){
				resp = JSON.parse(resp);
				
				if(resp.status == 'success'){
					$scope.user = resp.data.user;
					$scope.$apply();
				}
			});
		};
		
		// Edition controls
		ao.enableEdition = function(){
			ao.showFieldsAnimation();
			$scope.editMode = true;
		};
		
		ao.disableEdition = function(){
			$scope.editMode = false;
		};
		
		// Properties
		ao.addProperty = function(){
			$scope.properties.push({id:"-"+get_unique(), name: "Nova propietat", value:""})
		};
		
		ao.removeProperty = function(){
			if($scope.activeProperty.isFixed == true){
				
			}else{
				var i = $scope.properties.indexOf($scope.activeProperty);
				$scope.properties.splice(i, 1);
			}
		};
		
		ao.cancelChanges = function(){
			$("#user_form_edition_btn").closeToolbar();
			ao.loadProperties();
		};
		
		ao.setActiveProperty = function(prop){
			$scope.activeProperty = prop;
		};
		
		ao.isActive = function(prop){
			return angular.equals(prop, $scope.activeProperty);
		};
		
		ao.loadProperties = function(){
			PropertiesService.getProperties()
			.done(function(resp){
				resp = JSON.parse(resp)
				
				if(resp.status == 'success'){
					$scope.properties = resp.data.properties;
					$scope.$apply();
				}else{
					showNotification('error', false, "No hem pogut carregar les dades correctament.");
				}
			});
		};
		
		ao.saveChanges = function(){
			console.log($scope.propertiesForm.$valid);
			if($scope.propertiesForm.$valid){
				PropertiesService.saveProperties($scope.properties)
				.done(function(resp){
					resp = JSON.parse(resp);
					console.log(resp);
					if(resp.status == 'success'){
						ao.loadProperties();
						$("#user_form_edition_btn").closeToolbar();
						showNotification('success', false, "Canvis desats correctament.", 3000);
					}
				});
			}
		};
		
		ao.showFieldsAnimation = function(){
			$(".user_properties li").addClass("active")
			
			setTimeout(function(){
				$(".user_properties li").removeClass("active")
			}, 150);
		};
		
		$(document).on("ev_toolbar_opened", function(e, d){
			d = $(d)
			
			if(d.attr("data-controls") === 'edition_mode'){
				ao.enableEdition();
				$scope.$apply();
			}
		});
		
		$(document).on("ev_toolbar_closed", function(e, d){
			d = $(d)
			
			if(d.attr("data-controls") === 'edition_mode'){
				ao.disableEdition();
			}
		});
		
		// Executem les funcions en quant es carregui el controlador
		ao.init();
	}]);
})();