(function(){
	var app = angular.module("hafe-alerts");
	
	app.controller("ViewAlertController", ['$scope', '$http', '$location', 'PropertiesService', 'AuthService', '$routeParams', 'AlertsService', function($scope, $http, $location, PropertiesService, AuthService, $routeParams, AlertSrv){
		var ao = this;
		
		$scope.user = {};
		$scope.properties = [];
		$scope.code = $routeParams.alertCode;
		$scope.alert = {};
		
		ao.init = function(){
			AuthService.validateToken(false)
			.done(function(resp){
				if(resp){
					ao.getAlertInfo();
				}else{
					$location.path('/login/ac/'+$scope.code);
					setTimeout(function(){$scope.$apply()});
					showNotification('warning', false, "Has d'iniciar sessió per a poder veure les alertes.", false, true);
				}
			})
		};
		
		ao.getAlertInfo = function(){
			AlertSrv.getInfo($scope.code)
			.done(function(resp){
				resp = JSON.parse(resp);
				
				if(resp.status == 'success'){
					$scope.user.code = resp.data.user.code;
					
					$scope.alert = resp.data.alert;
					$scope.alert.date = get_local_date($scope.alert.date);
					
					ao.loadUserInfo();
					ao.loadProperties();
					ao.constructMap();
				}else{
					$location.path('/login');
					setTimeout(function(){$scope.$apply()});
					showNotification('error', false, "El codi d'alerta no és vàlid o no tens permisos per a veure'l.", false, true);
				}
			});
		};
		
		ao.loadUserInfo = function(){
			AuthService.getUserInfoFromCode($scope.user.code)
			.done(function(resp){
				resp = JSON.parse(resp);
				
				if(resp.status == 'success'){
					$scope.user = resp.data.user;
					$scope.$apply();
				}
			});
		};
		
		ao.loadProperties = function(){
			PropertiesService.getPropertiesFromCode($scope.user.code)
			.done(function(resp){
				resp = JSON.parse(resp)
				
				if(resp.status == 'success'){
					$scope.properties = resp.data.properties;
					$scope.$apply();
				}else{
					showNotification('error', false, "No hem pogut carregar les dades correctament.");
				}
			});
		};
		
		ao.registerVisualization = function(){
			$.ajax({
				type: 'post',
				url: 'server/visualizations/register.php',
				data: {token: AuthService.getToken(), code: $scope.code}
			}).done(function(resp){
				
			});
		};
		
		ao.constructMap = function(){
			var map = '<iframe width="100%" height="100%" frameborder="0" style="border:0" src="https://www.google.com/maps/embed/v1/place?key=AIzaSyDGfeLs7JwtxRlneIwQj6MJwzaTkfBZCvk &q='+$scope.alert.latitude+','+$scope.alert.longitude+'"></iframe>'
			$(".map_container").html(map);
		};
		
		// Executem les funcions en quant es carregui el controlador
		ao.init();
	}]);
})();