(function(){
	var app = angular.module("hafe-user");
	
	app.controller("ViewController", ['$scope', '$http', 'PropertiesService', 'AuthService', '$routeParams', function($scope, $http, PropertiesService, AuthService, $routeParams){
		var ao = this;
		
		$scope.user = {};
		$scope.properties = [];
		$scope.code = $routeParams.viewCode;
		
		ao.init = function(){
			ao.loadUserInfo();
			ao.loadProperties();
			ao.registerVisualization();
		};
		
		ao.loadUserInfo = function(){
			AuthService.getUserInfoFromCode($scope.code)
			.done(function(resp){
				resp = JSON.parse(resp);
				
				if(resp.status == 'success'){
					$scope.user = resp.data.user;
					$scope.$apply();
				}
			});
		};
		
		ao.loadProperties = function(){
			PropertiesService.getPropertiesFromCode($scope.code)
			.done(function(resp){
				resp = JSON.parse(resp)
				
				if(resp.status == 'success'){
					$scope.properties = resp.data.properties;
					$scope.$apply();
				}else{
					showNotification('error', false, "No hem pogut carregar les dades correctament.");
				}
			});
		};
		
		ao.registerVisualization = function(){
			$.ajax({
				type: 'post',
				url: 'server/visualizations/register.php',
				data: {token: AuthService.getToken(), code: $scope.code}
			}).done(function(resp){
				
			});
		};
		
		// Executem les funcions en quant es carregui el controlador
		ao.init();
	}]);
})();