<?php

	function _CheckUserExistance($mail){
		
		global $db;
		
		$return_data = initialize_return_data();
		
		$get_user_q = "SELECT id, password 
			FROM users
			WHERE mail = ".aqinnesc($mail)."  
				AND password IS NOT NULL 
				AND date_disabled IS NULL";
				
		$get_user = $db->query($get_user_q);
		
		if($db->error){
			
			$return_data['status'] = 'failed';
			$return_data['error'] = '37234873672';
			$return_data['line'] = __LINE__;
			$return_data['technical']['e'] = $db->error;
			
			return json_encode($return_data);
			
		}
		
		$return_data['status'] = 'success';
		$return_data['data']['exists'] = 0;
		
		if($get_user->num_rows > 0){
			
			$return_data['data']['exists'] = 1;
			
		}
		
		return json_encode($return_data);
		
	}
	
	function _ActivateUser($code){
		
		global $db;
		
		$now = get_now();
		
		$check_code_q = "SELECT id, mail 
			FROM users 
			WHERE activation_code = ".aqinnesc($code);
			
		$check_code = $db->query($check_code_q);
		
		if($check_code->num_rows > 0){
			
			$user = $check_code->fetch_object();
		
			$activate_user_q = "UPDATE users 
				SET date_validated = ".aqinnesc($now)." 
				WHERE activation_code = ".aqinnesc($code)." 
					AND date_validated IS NULL";
				
			$activate_user = $db->query($activate_user_q);
			
			if($db->error){
				
				$return_data['status'] = 'failed';
				$return_data['error'] = '34736473223';
				$return_data['line'] = __LINE__;
				$return_data['technical']['e'] = $db->error;
				
				return json_encode($return_data);
				
			}
			
			$return_data['status'] = 'success';
			$return_data['data']['user']['mail'] = $user->mail;
			
		}else{
			
			$return_data['status'] = 'failed';
			$return_data['status_id'] = 'invalid_code';
			
		}
		
		return json_encode($return_data);
		
	}
	
	function _DeleteAccount($user_id){
		
		global $db;
		
		$delete_qs = array();
		
		$check_user_q = "SELECT id, mail 
			FROM users 
			WHERE id = ".aqinnesc($user_id);
			
		$check_user = $db->query($check_user_q);
		
		if($check_user->num_rows > 0){
			
			$user = $check_user->fetch_object();
			
			// visualizations 
			$delete_qs['visualizations'] = "DELETE FROM visualizations WHERE target_user_id = ".aqinnesc($user_id);
			
			// card_fields 
			$delete_qs['card_fields'] = "DELETE FROM card_fields WHERE card_pref_id = (SELECT id FROM card_preferences WHERE user_id = ".aqinnesc($user_id).")";
			
			// card_preferences 
			$delete_qs['card_preferences'] = "DELETE FROM card_preferences WHERE user_id = ".aqinnesc($user_id);
			
			// user_properties
			$delete_qs['user_properties'] = "DELETE FROM user_properties WHERE user_id = ".aqinnesc($user_id);
			
			// emergency_alerts 
			$delete_qs['emergency_alerts'] = "DELETE FROM emergency_alerts WHERE target_user = ".aqinnesc($user_id);
			
			// password_resets 
			$delete_qs['password_resets'] = "DELETE FROM password_resets WHERE user_id = ".aqinnesc($user_id);
			
			// users 
			$delete_qs['users'] = "DELETE FROM users WHERE id = ".aqinnesc($user_id);
			
			foreach($delete_qs as $table => $q){
				
				$dbq = $db->query($q);
				
				if($db->error){
					
					$return_data['status'] = 'failed';
					$return_data['error'] = '28992837';
					$return_data['line'] = __LINE__;
					$return_data['technical']['e'] = $db->error;
					$return_data['technical']['d'] = "Table: ".$table;
					
					return json_encode($return_data);
					
				}
				
			}
			
			$return_data['status'] = 'success';
			
			_SendDeletedAccountMail($user->mail);
			
		}
		
		return json_encode($return_data);
		
	}
	
	function _RequestLostPassword($mail){
		
		global $db;
		
		$return_data = initialize_return_data();
		$now = get_now();
		
		$check_mail_q = "SELECT id AS id
			FROM users 
			WHERE mail = ".aqinnesc($mail);
		
		$check_mail = $db->query($check_mail_q);
		
		if($db->error){
			
			$return_data['status'] = 'failed';
			$return_data['error'] = '34736473223';
			$return_data['line'] = __LINE__;
			$return_data['technical']['e'] = $db->error;
			
			return json_encode($return_data);
			
		}
		
		if($check_mail->num_rows > 0){
			
			$user = $check_mail->fetch_object();
			$user_id = $user->id;
		
			$update_old_q = "UPDATE password_resets pr
				SET pr.date_disabled = ".aqinnesc($now)."
				WHERE pr.user_id = ".aqinnesc($user_id)." 
					AND pr.date_disabled IS NULL";
			
			$update_old = $db->query($update_old_q);
			
			if($db->error){
				
				$return_data['status'] = 'failed';
				$return_data['error'] = '12937873232';
				$return_data['line'] = __LINE__;
				$return_data['technical']['e'] = $db->error;
				
				return json_encode($return_data);
				
			}
			
			$reset_code = get_unique_str_checking("password_resets", "reset_code");
			
			$insert_new_q = "INSERT INTO password_resets 
					(user_id, reset_code, date_registered)
				VALUES 
					(".aqinnesc($user_id).", ".aqinnesc($reset_code).", ".aqinnesc($now).")";
				
			$insert_new = $db->query($insert_new_q);
			
			if($db->error){
				
				$return_data['status'] = 'failed';
				$return_data['error'] = '7382389263';
				$return_data['line'] = __LINE__;
				$return_data['technical']['e'] = $db->error;
				
				return json_encode($return_data);
				
			}
			
			$title = "Recuperació de contrasenya";
			$msg = "<p>Algú ha sol·licitat el restabliment de la contrasenya del seu compte. Si no has estat tu, no cal que facis res.</p>
				<p>Si desitges restablir la teva contrasenya, fes click a l'enllaç següent:</p>
				<p><a href='".get_app_url()."/restore-password/pc/".$reset_code."'>Restablir la contrasenya</a></p>
				<p>Gràcies per confiar en els nostres serveis.</p>";
			
			$m = send_mail($mail, $title, $msg);
			
			if($m){
			
				$return_data['status'] = 'success';
			
			}else{
				
				$return_data['status'] = 'failed';
				$return_data['status_id'] = 'mail_unsent';
				$return_data['error'] = '7382389263';
				
			}
			
		}else{
			
			$return_data['status'] = 'success';
			
		}
		
		return json_encode($return_data);
		
	}
	
	function _RestorePassword($pcode, $password){
		
		global $db;
		
		// $password must be md5() hashed
		$return_data = initialize_return_data();
		$now = get_now();
		
		$get_user_q = "SELECT user_id 
			FROM password_resets 
			WHERE reset_code = ".aqinnesc($pcode)." 
				AND date_used IS NULL 
				AND date_disabled IS NULL";
				
		$get_user = $db->query($get_user_q);
		
		if($db->error){
				
			$return_data['status'] = 'failed';
			$return_data['error'] = '8272987938';
			$return_data['line'] = __LINE__;
			$return_data['technical']['e'] = $db->error;
			
			return json_encode($return_data);
			
		}
		
		if($get_user->num_rows > 0){
			
			$user = $get_user->fetch_object();
			$user_id = $user->user_id;
			
			$return_data = json_decode(_ChangeUserPassword($user_id, $password));
			
			if($return_data->status == 'success'){
				
				$update_used_q = "UPDATE password_resets 
					SET date_used = ".aqinnesc($now)." 
					WHERE reset_code = ".aqinnesc($pcode);
					
				$update_used = $db->query($update_used_q);
				
				if($db->error){
				
					$return_data['status'] = 'failed';
					$return_data['error'] = '3467387468973';
					$return_data['line'] = __LINE__;
					$return_data['technical']['e'] = $db->error;
					
					return json_encode($return_data);
					
				}
				
			}
			
		}else{
			
			$return_data['status'] = 'failed';
			$return_data['status_id'] = 'invalid_code';
			
		}
		
		return json_encode($return_data);
		
	}
	
	function _SignupUser($mail, $password, $name, $surname){
		
		global $db;
		
		// $password must be md5() hashed
		$return_data = initialize_return_data();
		$now = get_now();
		$password = password_hash($password, PASSWORD_BCRYPT);
		$activation_code = get_unique_str_checking("users", "activation_code");
		$link_code = get_unique_str_checking("users", "link_code");
		
		$signup_user_q = "INSERT INTO users 
				(name, surname, mail, 
				password, activation_code, link_code, date_created) 
			VALUES 
				(".aqinnesc($name).", ".aqinnesc($surname).", ".aqinnesc($mail).", 
				".aqinnesc($password).", ".aqinnesc($activation_code).", ".aqinnesc($link_code).", ".aqinnesc($now).")";
		
		// Inserim l'usuari
		$signup_user = $db->query($signup_user_q);
		
		if($db->error || !$signup_user){
			
			$return_data['status'] = 'failed';
			$return_data['error'] = '466576894';
			$return_data['line'] = __LINE__;
			$return_data['technical']['e'] = $db->error;
			
			return json_encode($return_data);
			
		}else{
			
			$user_id = $db->insert_id;
			
			$send_mail = _SendUserActivationMail($mail);
			
			if(!$send_mail){
				
				$return_data['status'] = 'failed';
				$return_data['status_id'] = 'mail_unsent';
				$return_data['error'] = '28739287';
				
				return json_encode($return_data);
				
			}
			
			$add_fixed_fields = json_decode(_AddFixedFields($user_id));
			
			if($add_fixed_fields->status != 'success'){
				
				return json_encode($add_fixed_fields);
				
			}
			
			$add_default_preferences = json_decode(_AddDefaultCardPreferences($user_id));
			
			if($add_default_preferences->status != 'success'){
				
				return json_encode($add_default_preferences);
				
			}
			
			$return_data['status'] = 'success';
			$return_data['data']['user']['id'] = $user_id;
			
		}
		
		return json_encode($return_data);
		
	}
	
	function _SendUserActivationMail($mail){
		
		global $db;
		
		$get_info_q = "SELECT id, activation_code 
			FROM users 
			WHERE mail = ".aqinnesc($mail);
		
		$get_info = $db->query($get_info_q);
		
		if($db->error){
			
			$return_data['status'] = 'failed';
			$return_data['error'] = '20289383';
			$return_data['line'] = __LINE__;
			$return_data['technical']['e'] = $db->error;
			
			return json_encode($return_data);
			
		}
		
		$user = $get_info->fetch_object();
		
		$title = "HAFE - Activació d'usuari";
		$msg = "<p>Gràcies per confiar la teva seguretat a HAFE, l'aplicació que permet als serveis d'emergència agilitzar el procés d'atenció al pacient.</p>
			<p>Sisplau, fes clic en <a href='".get_app_url()."/login/activate/".$user->activation_code."'>aquest enllaç</a> per a activar el teu compte d'usuari.</p>
			<p>Un cop activat el teu compte, ja podràs iniciar sessió amb la contrasenya que has especificat i podràs començar a utilitzar la plataforma.</p>
			<p>Recorda d'imprimir la teva targeta a l'apartat <i>Edició de targetes</i> per a dur-la sempre a sobre, un cop hagis introduït la informació sobre les teves dades mèdiques.</p>
			<p>Gràcies, un cop més, per confiar en nosaltres.</p>";
		
		return send_mail($mail, $title, $msg);
	
	}
	
	function _SendDeletedAccountMail($mail){
		
		$title = "HAFE - Compte esborrat";
		$msg = "<p>T'informem que el teu compte, així com totes les dades associades a ell, han estat esborrats permanentment de la nostra plataforma.</p>
			<p>Si en algun moment desitges tornar a utilitzar els nostres serveis, no dubtis en visitar de nou <a href='".get_app_url()."/login'>la nostra aplicació web</a> i tornar-te a donar d'alta.</p>
			<p>Des de l'equip de HAFE volem donar-te les gràcies per haver confiat en nosaltres i els nostres productes.</p>
			<p>Esperem tornar-te a veure aviat.</p>";
		
		return send_mail($mail, $title, $msg);
	
	}
	
	function _CheckToken($token, $is_emergency){
		
		global $db;
		
		$return_data = initialize_return_data();
		
		$get_user_q = "SELECT id, token, token_expire
			FROM users
			WHERE token = ".aqinnesc($token)."  
				AND password IS NOT NULL 
				AND date_disabled IS NULL 
				AND token_expire > '".get_now()."'";
				
		if(property_is_defined($is_emergency) && $is_emergency){
			
			$get_user_q .= " AND emergency_service IS NOT NULL";
			
		}
				
		$get_user = $db->query($get_user_q);
		
		if($get_user->num_rows > 0){
			
			$return_data['status'] = 'success';
			
			$u = $get_user->fetch_object();
			
			$return_data['data']['user']['id'] = $u->id;
			$return_data['data']['user']['token']['code'] = $u->token;
			$return_data['data']['user']['token']['expire'] = $u->token_expire;
			$return_data['data']['user']['token']['signature'] = "";
			
		}
		
		return json_encode($return_data);
		
	}
	
	function _GetTokenUser($token, $is_emergency){
		
		global $db;
		
		$resp = json_decode(_CheckToken($token, $is_emergency));
		
		$user_id = false;
		
		if($resp->status == 'success' && property_is_defined($resp->data->user->id)){
			
			$user_id = $resp->data->user->id;
			
		}
		
		return $user_id;
		
	}
	
	function _GetCodeLinkUser($code){
		
		global $db;
		
		$return_data = initialize_return_data();
		$user_id = false;
		
		$get_code_user_q = "SELECT id 
			FROM users 
			WHERE link_code = ".aqinnesc($code);
			
		$get_code_user = $db->query($get_code_user_q);
		
		if($db->error){
			
			return false;
		
		}else{
			
			if($get_code_user->num_rows > 0){
				
				$user = $get_code_user->fetch_object();
				
				$user_id = $user->id;
				
			}
			
		}
		
		return $user_id;
		
	}
	
	function _LoginUser($mail, $password){
		
		global $db;
		
		// password must be hashed in md5()
		
		$return_data = initialize_return_data();
		
		// Aconseguim l'usuari que tingui aquest mail i hagi estat validat i no deshabilitat
		$get_user_q = "SELECT id, password 
			FROM users
			WHERE mail = ".aqinnesc($mail)."  
				AND password IS NOT NULL 
				AND date_validated IS NOT NULL 
				AND date_disabled IS NULL ";
				
		$get_user = $db->query($get_user_q);
		
		if($db->error){
			
			$return_data['status'] = 'failed';
			$return_data['error'] = '827832929';
			$return_data['line'] = __LINE__;
			$return_data['technical']['e'] = $db->error;
			
			return json_encode($return_data);
			
		}
		
		if($get_user->num_rows > 0){
			
			$user = $get_user->fetch_object();
			
			// I comprovem si, efectivament, el password és correcte
			if(password_verify($password, $user->password)){
				
				$return_data['status'] = 'success';
				
				$u = array();
				$u['id'] = $user->id;
				$u['token']['code'] = generate_token_db();
				$u['token']['expire'] = get_token_expire_date();
				$u['token']['signature'] = '';
				
				// Actualitzem la base de dades per a posar el nou Token
				$db->query("UPDATE users 
					SET token = ".aqinnesc($u['token']['code']).", 
						token_expire = ".aqinnesc($u['token']['expire'])." 
					WHERE id = ".aqinnesc($u['id']));
				
				// Retornem l'usuari amb les seves dades necessaries
				$return_data['data']['user'] = $u;
				
			}
			
		}
		
		return json_encode($return_data);
		
	}
	
	function _GetUserInfo($user_id){
		
		global $db;
		
		$return_data = initialize_return_data();
		
		$get_user_info_q = "SELECT 
				us.name AS name, 
				us.surname AS surname,
				us.mail AS mail,
				IFNULL(us.photo_src, '') AS photo,
				us.link_code AS user_code
			FROM users us 
			WHERE us.id = ".aqinnesc($user_id);
			
		$get_user_info = $db->query($get_user_info_q);
		
		if($db->error || $get_user_info->num_rows == 0){
			
			$return_data['status'] = 'failed';
			$return_data['error'] = '827832929';
			$return_data['line'] = __LINE__;
			$return_data['technical']['e'] = $db->error;
			
			return json_encode($return_data);
			
		}
		
		$return_data['status'] = 'success';
		
		$user = $get_user_info->fetch_object();
		
		$return_data['data']['user']['name'] = $user->name;
		$return_data['data']['user']['surname'] = $user->surname;
		$return_data['data']['user']['mail'] = $user->mail;
		$return_data['data']['user']['photo'] = $user->photo;
		$return_data['data']['user']['code'] = $user->user_code;
		
		return json_encode($return_data);
		
	}
	
	function _ChangeUserPassword($user_id, $password){
		
		global $db;
		
		// $password must be md5 hashed
		$c_password = password_hash($password, PASSWORD_BCRYPT);
		
		$update_pass_q = "UPDATE users 
			SET password = ".aqinnesc($c_password)."
			WHERE id = ".aqinnesc($user_id);
			
		$update_pass = $db->query($update_pass_q);
		
		if($db->error){
			
			$return_data['status'] = 'failed';
			$return_data['error'] = '827832929';
			$return_data['line'] = __LINE__;
			$return_data['technical']['e'] = $db->error;
			
			return json_encode($return_data);
			
		}
		
		$return_data['status'] = 'success';
		
		return json_encode($return_data);
		
	}
	
	function _CheckUserCode($code){
		
		global $db;
		
		$return_data = initialize_return_data();
		
		$check_code_q = "SELECT id 
			FROM users 
			WHERE link_code = ".aqinnesc($code);
			
		$check_code = $db->query($check_code_q);
		
		if($db->error){
			
			$return_data['status'] = 'failed';
			$return_data['error'] = '86767463543';
			$return_data['line'] = __LINE__;
			$return_data['technical']['e'] = $db->error;
			
			return json_encode($return_data);
			
		}else{
			
			if($check_code->num_rows > 0){
				
				$return_data['status'] = 'success';
				
			}
			
		}
		
		return json_encode($return_data);
		
	}

?>