<?php

	function _SendEmergencyAlert($code, $latitude, $longitude){
		
		global $db;
		
		$return_data = initialize_return_data();
		$now = get_now();
		
		$alert_code = get_unique_str_checking("emergency_alerts", "alert_code");
		
		$insert_alert_q = "INSERT INTO emergency_alerts 
				(alert_code, target_user, latitude, longitude, date_created) 
			SELECT ".aqinnesc($alert_code).", us.id, ".aqinnesc($latitude).", ".aqinnesc($longitude).", ".aqinnesc($now)." 
			FROM users us
			WHERE us.link_code = ".aqinnesc($code)."
			LIMIT 1";
			
		$insert_alert = $db->query($insert_alert_q);
		
		if($db->error){
			
			$return_data['status'] = 'failed';
			$return_data['error'] = '86767463543';
			$return_data['line'] = __LINE__;
			$return_data['technical']['e'] = $db->error;
			
			return json_encode($return_data);
			
		}else{
			
			if(_SendEmergencyMail($alert_code)){
				
				$return_data['status'] = 'success';
				$return_data['data']['alert']['id'] = $db->insert_id;
				$return_data['data']['alert']['code'] = $alert_code;
				
			}else{
				
				$return_data['status'] = 'failed';
				$return_data['status_id'] = 'mail_unsent';
				
			}
			
		}
		
		return json_encode($return_data);
		
	}
	
	function _SendEmergencyMail($alert_code){
		
		$title = "Nova alerta d'emergència";
		$msg = "<p>S'ha rebut una nova alerta d'emergència.</p>";
		$msg .= "<p>Podeu accedir a la seva visualització mitjançant aquest enllaç:</p>";
		$msg .= "<p><a href='".get_app_url()."/view-alert/".$alert_code."'>Visualitzar alerta</a>.</p>";
		$msg .= "<p>Gràcies per confiar en els nostres serveis.</p>";
		
		// return send_mail("emergencies@gencat.cat", $title, $msg);
		return send_mail("albertnevado@uoc.edu", $title, $msg);
		
	}
	
	function _CheckAlertCode($user_id, $code){
		
		global $db;
		
		$return_data = initialize_return_data();
		$now = get_now();
		
		$check_code_q = "SELECT 
				al.id AS id, 
				al.latitude AS latitude, 
				al.longitude AS longitude,
				al.date_created AS date_created,
				us.link_code AS user_code
			FROM emergency_alerts al 
			INNER JOIN users us 
				ON us.id = al.target_user
			WHERE alert_code = ".aqinnesc($code);
			
		$check_code = $db->query($check_code_q);
		
		if($db->error){
			
			$return_data['status'] = 'failed';
			$return_data['error'] = '78686544343';
			$return_data['line'] = __LINE__;
			$return_data['technical']['e'] = $db->error;
			
			return json_encode($return_data);
			
		}else{
			
			if($check_code->num_rows > 0){
				
				$return_data['status'] = 'success';
				
				$alert = $check_code->fetch_object();
				
				$return_data['data']['alert']['id'] = $alert->id;
				$return_data['data']['alert']['latitude'] = $alert->latitude;
				$return_data['data']['alert']['longitude'] = $alert->longitude;
				$return_data['data']['alert']['date'] = $alert->date_created;
				$return_data['data']['user']['code'] = $alert->user_code;
				
				_RegisterUserVisualization($user_id, $code, true);
				
				$update_alert_q = "UPDATE emergency_alerts 
					SET opened_by = ".aqinnesc($user_id).", 
						date_viewed = ".aqinnesc($now)." 
					WHERE alert_code = ".aqinnesc($code)." 
						AND opened_by IS NULL";
					
				$update_alert = $db->query($update_alert_q);
				
				// No interceptem cap error de la query ja que si ho notifiquéssim a la app, 
				// no deixaria veure l'alerta - cosa que pot perjudicar la finalitat de l'app
				
			}
			
		}
		
		return json_encode($return_data);
		
	}
	
?>