<?php
	
	function get_now(){
		
		return date("Y-m-d H:i:s");
		
	}
	
	function get_app_url(){
		
		if(PRODUCTION == 1){
			
			if(SSLENABLED == 1){
				
				return "https://eimtcms.uoc.edu/~albertnevado/tfg";
				
			}else{
				
				return "http://eimtcms.uoc.edu/~albertnevado/tfg";
				
			}
			
		}else{
			
			if(SSLENABLED == 1){
				
				return 'https://hafe.localhost/tfg';
				
			}else{
				
				return 'http://localhost/tfg';
				
			}
			
		}
		
	}
	
	function initialize_return_data(){
		
		$return_data['status'] = 'failed';
		$return_data['data'] = array();
		
		return $return_data;
		
	}
	
	function aqinnesc_array($arr){
		
		global $db;
		
		$toreturn = array();
		
		foreach($arr as $ar){
			
			$toreturn[] = $db->real_escape_string($ar);
			
		}
		
		return $toreturn;
		
	}
	
	function aqinn($str, $canempty){
		
		return add_quotes_if_not_null($str, $canempty);
		
	}
	
	function aqinnesc($str, $canempty){
		
		global $db;
		
		return add_quotes_if_not_null($db->real_escape_string($str), $canempty);
		
	}
	
	function add_quotes_if_not_null($str, $canempty){
		
		$to_return = '';
		
		if(!isset($canempty)) $canempty = false;
		
		if(!is_null($str) && $str != ''){
			
			$to_return = "'".$str."'";
			
		}else{
		
			if($str == '' && $canempty){
			
				$to_return = "'".$str."'";
			
			}else{
		
				$to_return = "NULL";
				
			}
		
		}
		
		return $to_return;
	
	}
	
	function property_has_value($prop, $value){
		// Comprova que la propietat estigui definida I tingui el valor donat
		return property_is_defined($prop, true) && $prop == $value;
		
	}
	
	function property_is_defined($prop, $can_be_zero){
		
		if(!isset($can_be_zero)) $can_be_zero = false;
		
		$is_zero = $prop === 0 || $prop === '0';
		
		return isset($prop) && $prop !== '' && (!$is_zero || ($can_be_zero && $is_zero));
		
	}
	
	function any_are_defined(){
		// Comprova si ALGUNA les propietats que rebem estiguin definides
		
		$are_defined = false;
		
		foreach (func_get_args() as $param) {
			
			if(property_is_defined($param)) $are_defined = true;
		
		}
		
		return $are_defined;
		
	}
	
	function properties_are_defined(){
		// Comprova que TOTES les propietats que rebem estiguin definides
		
		$are_defined = true;
		
		foreach (func_get_args() as $param) {
			
			if(!property_is_defined($param)) $are_defined = false;
		
		}
		
		return $are_defined;
		
	}
	
	function generateRandomString($length = 8){
		
		$password = "";

		// Caràcters possibles a incloure a la clau
		$possible = "2346789bcdfghjkmnpqrtvwxyzBCDFGHJKLMNPQRTVWXYZ";

		// Longitud màxima de la clau
		$maxlength = strlen($possible);
	  
		// check for length overflow and truncate if necessary
		if ($length > $maxlength) {
		  $length = $maxlength;
		}
		
		// Comptador de caràcters actuals
		$i = 0; 
		
		while ($i < $length) { 
		
			$char = substr($possible, mt_rand(0, $maxlength-1), 1);
			
		  // Comprovem els caracters utilitzats per a no repetir lletres
			if (!strstr($password, $char)) { 

				$password .= $char;
				$i++;

			}

		}

		return $password;

	}
	
	function get_token_expire_date(){
		
		return date('Y-m-d H:i:s', (time() + 60*60));
	
	}
	
	function get_fixed_fields(){
		
		$fixed_fields = array();
		
		$fixed_fields[] = (object) array("name" => "Direcció");
		$fixed_fields[] = (object) array("name" => "Persona de contacte");
		$fixed_fields[] = (object) array("name" => "Malalties");
		$fixed_fields[] = (object) array("name" => "Al·lèrgies");
		$fixed_fields[] = (object) array("name" => "Medicació");
		
		return $fixed_fields;
		
	}
	
	function send_mail($mail, $title, $msg){
		
		$return_data = initialize_return_data();
		
		$content = file_get_contents(__DIR__ . "/../../server/mailing/mail_template.html");
		
		$headers  = 'MIME-Version: 1.0' . "\r\n";
		$headers .= 'Content-type: text/html; charset=UTF-8' . "\r\n";
		
		$headers .= 'From: HAFE Administration <no-reply@hafe.com>' . "\r\n";
		$headers .= 'Reply-To: <no-reply@hafe.com>' . "\r\n";
		$headers .= 'X-Mailer: PHP/' . phpversion();
		
		$content = str_replace("{{title}}", $title, $content);
		$content = str_replace("{{message}}", $msg, $content);
		
		$send_mail = mail($mail, $title, $content, $headers);
		
		if($send_mail){
		
			$return_data['status'] = 'success';
		
		}else{
		
			$return_data['status'] = 'failed';
			$return_data['error'] = '3000701';
		
		}
		
		return $send_mail;
	
	}
	
	function generate_token_db(){
		
		global $db;
		
		$unique_token;
		$q;
		
		do{
			$unique_token = generate_token();
			$q = $db->query("SELECT id FROM users WHERE token = '".$unique_token."'");
		}while($q->num_rows > 0);
		
		return $unique_token;
		
	}
	
	function get_unique_str_checking($database, $field){
		
		global $db;
		
		$unique_token;
		$q;
		
		do{
			$unique_token = generateRandomString(12);
			$q = $db->query("SELECT id FROM ".$database." WHERE ".$field." = '".$unique_token."'");
		}while($q->num_rows > 0);
		
		return $unique_token;
		
	}
	
	function generate_token(){
		$part1 = generateRandomString(12);
		$part2 = generateRandomString(12);
		$part3 = generateRandomString(12);
		
		return $part1."-".$part2."-".$part3;
	}
	
?>