<?php

	function _GetUserVisualizations($user_id){
		
		global $db;
		
		$return_data = initialize_return_data();
		
		$get_visualizations_q = "SELECT 
				vi.id AS id,
				vi.reader_user_id AS reader_user_id,
				vi.date_read AS date_read,
				us.name AS user_name, 
				us.surname AS user_surname,
				IFNULL(us.photo_src, '') AS user_photo,
				emsrv.name AS emergency_name 
			FROM visualizations vi 
			INNER JOIN users us 
				ON us.id = vi.reader_user_id 
			LEFT JOIN emergency_services emsrv
				ON emsrv.id = us.emergency_service 
			WHERE vi.target_user_id = ".aqinnesc($user_id)."
			ORDER BY vi.date_read DESC 
			LIMIT 20";
				
		$get_visualizations = $db->query($get_visualizations_q);
		
		if($db->error){
			
			$return_data['status'] = 'failed';
			$return_data['error'] = '76238417263';
			$return_data['line'] = __LINE__;
			$return_data['technical']['e'] = $db->error;
			
			return json_encode($return_data);
			
		}else{
			
			$return_data['status'] = 'success';
			$return_data['data']['visualizations'] = array();
			
			while($vis = $get_visualizations->fetch_object()){
				
				$v = array();
				$v['id'] = $vis->id;
				$v['user']['name'] = $vis->user_name;
				$v['user']['surname'] = $vis->user_surname;
				$v['user']['photo'] = $vis->user_photo;
				$v['emergency']['name'] = $vis->emergency_name;
				$v['dateRead'] = $vis->date_read;
				
				$return_data['data']['visualizations'][] = $v;
				
			}
			
		}
		
		return json_encode($return_data);
		
	}
	
	function _RegisterUserVisualization($user_id, $code, $is_emergency){
		
		global $db;
		
		$return_data = initialize_return_data();
		$now = get_now();
		
		if($is_emergency){
			
			$insert_vis_q = "INSERT INTO visualizations 
					(target_user_id, reader_user_id, date_read) 
				SELECT al.target_user, ".aqinnesc($user_id).", ".aqinnesc($now)." 
				FROM emergency_alerts al 
				WHERE al.alert_code = ".aqinnesc($code)." 
				LIMIT 1";
			
		}else{
			
			$insert_vis_q = "INSERT INTO visualizations 
					(target_user_id, reader_user_id, date_read) 
				SELECT us.id, ".aqinnesc($user_id).", ".aqinnesc($now)." 
				FROM users us 
				WHERE us.link_code = ".aqinnesc($code)." 
				LIMIT 1";
			
		}
			
		$insert_vis = $db->query($insert_vis_q);
		
		if($db->error || !$insert_vis){
			
			$return_data['status'] = 'failed';
			$return_data['error'] = '84678929282';
			$return_data['line'] = __LINE__;
			$return_data['technical']['e'] = $db->error;
			
			return json_encode($return_data);
			
		}else{
			
			$return_data['status'] = 'success';
			
		}
		
		return json_encode($return_data);
		
	}
	
?>