(function(){
	angular.module('hafe-auth.services', []).factory('AuthService', ['$location', function($location){
		var ao = this;
		
		var return_obj = {
			"loginUser": loginUser,
			"validateToken": validateToken,
			"processLogin": processLogin,
			"getToken": getToken,
			"requestLostPassword": requestLostPassword,
			"restorePassword": restorePassword,
			"logout": logout,
			"getUserInfo": getUserInfo,
			"getUserInfoFromCode": getUserInfoFromCode,
			"checkUserCode": checkUserCode,
			"activateUser": activateUser,
			"deleteAccount": deleteAccount
		};
		
		var _init = {
			code: '',
			expire: '',
			signature: ''
		};
		
		ao.token = {};
		
		if(localStorage['token'] != undefined){
			ao.token = JSON.parse(localStorage['token']);
		}else{
			setToken(_init);
		}
		
		function getToken(whole){
			if(whole) return ao.token;
			else return ao.token.code;
		};
		
		function getUserInfo(){
			return $.ajax({
				type: 'post',
				url: 'server/auth/get_user_info.php', 
				data: {token: ao.token.code}
			});
		};
		
		function checkUserCode(_code){
			return $.ajax({
				type: 'post',
				url: 'server/auth/check_code.php',
				data: {code: _code}
			});
		};
		
		function getUserInfoFromCode(_code){
			return $.ajax({
				type: 'post',
				url: 'server/auth/get_user_info.php', 
				data: {token: ao.token.code, code: _code}
			});
		};
		
		function loginUser(_mail, _password){
			var _params = {
				mail: _mail, 
				password: _password
			};
			
			localStorage['mail'] = _mail;
			
			return $.ajax({
				type: 'post',
				url: 'server/auth/login.php', 
				data: _params
			});
		};
		
		function logout(){
			setToken(_init);
		};
		
		function validateToken(redirect){
			var toreturn = $.Deferred();
			
			checkToken().done(function(resp){
				toreturn.resolve(
					processLogin(JSON.parse(resp), redirect)
				)
			});
			
			return toreturn.promise();
		};
		
		function processLogin(d, redirect){
			var global_process = false;
			if(redirect === undefined) redirect = true;
			
			if(d.status == 'success'){
				if(d.data !== undefined && d.data.user !== undefined){
					setToken(d.data.user.token)
					global_process = true
				}
			}
			
			if(global_process){
				return true;
			}else{
				logout();
				
				if(redirect){
					$location.path('/login');
				}
				
				return false;
			}
		};
		
		function setToken(tk){
			ao.token = tk;
			localStorage['token'] = JSON.stringify(ao.token);
		};
		
		function checkToken(){
			var toreturn = $.Deferred();
			
			$.ajax({
				type: 'post',
				url: 'server/auth/check_token.php', 
				data: {token: ao.token.code}
			}).done(function(msg){
				toreturn.resolve(msg)
			})
			
			return toreturn.promise();
		};
		
		function requestLostPassword(_mail){
			return $.ajax({
				type: 'post',
				url: 'server/auth/request_lost_password.php', 
				data: {mail: _mail}
			});
		};
		
		function restorePassword(_pcode, _pass){
			return $.ajax({
				type: 'post',
				url: 'server/auth/restore_password.php', 
				data: {passwordCode: _pcode, password: _pass}
			});
		};
		
		function activateUser(_code){
			return $.ajax({
				type: 'post',
				url: 'server/auth/activate_user.php', 
				data: {code: _code}
			});
		};
		
		function deleteAccount(){
			return $.ajax({
				type: 'post',
				url: 'server/auth/delete_account.php', 
				data: {token: ao.token.code}
			});
		};
		
		return return_obj;
		
	}]);
})();