(function(){
	angular.module('hafe-user.properties').factory('PropertiesService', ['$http', 'AuthService', function($http, AuthService){
		var ao = this;
		
		var return_obj = {
			"getProperties": getProperties,
			"saveProperties": saveProperties,
			"getPropertiesFromCode": getPropertiesFromCode
		};
		
		function getProperties(){
			return $.ajax({
				method: 'post',
				url: 'server/properties/get.php',
				data: {token: AuthService.getToken()}
			});
		};
		
		function getPropertiesFromCode(_code){
			return $.ajax({
				method: 'post',
				url: 'server/properties/get.php',
				data: {token: AuthService.getToken(), code: _code}
			});
		};
		
		function saveProperties(props){
			return $.ajax({
				type: 'post',
				url: 'server/properties/save.php',
				data: {token: AuthService.getToken(), properties: JSON.stringify(props)}
			});
		};
		
		return return_obj;
		
	}]);
})();